//
//  SelfAttitudeCalculator.swift
//  psychology_ios_native
//
//  Created by Eldar Goloviznin on 16/10/2019.
//  Copyright © 2019 Psychology. All rights reserved.
//

import Foundation

struct SelfAttitudeCalculator: TestCalculator {
    
    let test: Test
    
    private let ЗамкнутостьIndices = [
        1, 3, 9, 48, 53, 56, 65
    ]
    private let ЗамкнутостьDisagreeIndices = [
        21, 62, 86, 98
    ]
    private let ЗамкнутостьAdvices = [
        "У вас выраженное желание соответствовать общепринятым нормам поведения и взаимоотношений с окружающими людьми. У вас высокая мотивация получить социальное одобрение. Вы склонны избегать открытых отношений с самим собой. Причиной может быть или недостаточность навыков самонаблюдения, самоанализа, поверхностное видение себя, или осознанное нежелание раскрывать себя, признавать существование личных проблем.",
        "Вы бываете честны и открыты с самим собой, вы умеете периодически наблюдать и анализировать свое поведение мысли, эмоции. Но при этом ждете социального одобрения, положительных оценок от окружающих людей. В критичных жизненных ситуациях может преобладать защитное поведение.",
        "Вы внутренне честны и открыты с самим собой. Вы владеете навыками самонаблюдения и самоанализа, глубоко понимаете себя. Вы порой излишне критичны по отношению к себе. Во взаимоотношениях с людьми доминирует ориентация на собственное видение ситуации, происходящего."
    ]
    
    private let СамоуверенностьIndices = [
        7, 24, 30, 35, 36, 51, 52, 58, 61, 73, 82
    ]
    private let СамоуверенностьDisagreeIndices = [
        20, 80, 103
    ]
    private let СамоуверенностьAdvices = [
        "Вы уважаете себя, имеете выраженную самоуверенность, ощущение силы собственного \"Я\", высокую смелость в общении. У вас доминирует мотив успеха. Вы довольны собой, своими начинаниями и достижениями, ощущаете свою компетентность и способность решать многие жизненные вопросы. Препятствия на пути к достижению цели воспринимаете как преодолимые. Проблемы затрагивают неглубоко, переживаются недолго.",
        "В привычных для себя ситуациях вы сохраняете работоспособность, уверенность в себе, ориентацию на успех начинаний. При неожиданном появлении трудностей уверенность в себе снижается, нарастают тревога, беспокойство.",
        "Вы не уважаете себя, не уверены в своих возможностях, сомневаетесь в своих способностях. Вы не доверяете своим решениям, часто сомневаетесь в способности преодолевать трудности и препятствия, достигать намеченных целей. Возможно вы избегаете контактов с людьми, глубоко погружаетесь в собственные проблемы, испытываете внутреннюю напряженность."
    ]
    
    private let СаморуководствоIndices = [
        43, 44, 45, 74, 76, 84, 90, 105, 106, 108, 110]
    private let СаморуководствоDisagreeIndices = [
        109
    ]
    private let СаморуководствоAdvices = [
        "Основным источником развития своей личности, регулятором достижений и успехов вы считаете себя самого. Вы ощущаете собственное \"Я\" как внутренний стержень, который координирует и направляет всю активность, организует поведение и отношения с людьми, что делает вас способным прогнозировать свои действия и последствия возникающих контактов с окружающими. Вы ощущаете себя способным оказывать сопротивление внешним влияниям, противиться судьбе и стихии событий. Вам свойственен контроль над эмоциональными реакциями и переживаниями по поводу себя.",
        "Вы относитесь к своему \"Я\" в зависимости от степени адаптированности в ситуации. В привычных для себя условиях существования, в которых все возможные изменения знакомы и хорошо прогнозируемы, вы можете проявлять выраженную способность к личному контролю. В новых для себя ситуациях регуляционные возможности \"Я\" ослабевают, усиливается склонность к подчинению средовым воздействиям.",
        "Вы верите в подвластность своего \"Я\" внешним обстоятельствам и событиям. Ваши механизмы саморегуляции ослаблены. Волевой контроль недостаточен для преодоления внешних и внутренних препятствий на пути к достижению цели. Основным источником происходящего вы считаете внешние обстоятельства. Причины, заключающиеся непосредственно в вашем поведении или мышлении, ваши защитные механизмы либо отрицают, либо вытесняют в подсознание. Переживания относительно собственного \"Я\" сопровождаются внутренним напряжением."
    ]
    
    private let ОтраженноеСамоотношениеIndices = [
        2, 5, 29, 41, 42, 50, 102
    ]
    private let ОтраженноеСамоотношениеDisagreeIndices = [
        13, 18, 34, 85
    ]
    private let ОтраженноеСамоотношениеAdvices = [
        "Вы воспринимаете себя принятым окружающими людьми. Вы чувствуете, что вас любят другие, ценят за личностные и духовные качества, за совершаемые поступки и действия, за приверженность групповым нормам и правилам. Вы ощущаете в себе общительность, эмоциональную открытость для взаимодействия с окружающими, легкость установления деловых и личных контактов.",
        "С вашей точки зрения, положительное отношение окружающих распространяется лишь на определенные качества, на определенные поступки; а другие личностные проявления способны вызывать у них раздражение и непринятие.",
        "Вы относите себя к людям, неспособным вызвать уважение у окружающих. Вы считаете, что вызываете у других людей осуждение и порицание. Одобрение, поддержка от других не ожидаются."
    ]
    
    private let СамоценностьIndices = [
        8, 16, 39, 54, 57, 68, 70, 75, 100
    ]
    private let СамоценностьDisagreeIndices = [
        15, 26, 31, 46, 83
    ]
    private let СамоценностьAdvices = [
        "Вы высоко оцениваете свой духовный потенциал, богатство своего внутреннего мира. Вы склонны воспринимать себя как индивидуальность и высоко ценить собственную неповторимость. Уверенность в себе помогает вам противостоять средовым воздействиям, рационально воспринимать критику в свой адрес.",
        "Вы избирательно относитесь к себе. Вы склонны высоко оценивать ряд своих качеств, признавать их уникальность. Другие же качества явно недооцениваются, поэтому замечания окружающих могут вызвать ощущение малоценности, личной несостоятельности.",
        "Вы глубоко сомневаетесь в уникальности своей личности, недооцениваете свое духовное \"Я\". Неуверенность в себе ослабляет ваше сопротивление средовым влияниям. Повышенная чувствительность к замечаниям и критике окружающих в свой адрес делает вас обидчивым и ранимым, склонным не доверять своей индивидуальности."
    ]
    
    private let СамопринятиеIndices = [
        10, 12, 17, 28, 40, 49, 63, 72, 77, 79, 88, 97
    ]
    private let СамопринятиеAdvices = [
        "Вы склонны воспринимать все стороны своего \"Я\", принимать себя во всей полноте поведенческих проявлений. Общий фон восприятия себя положительный. Вы часто ощущаете симпатию к себе, ко всем качествам своей личности. Свои недостатки считаете продолжением достоинств. Неудачи, конфликтные ситуации не дают основания для того, чтобы считать, себя плохим человеком.",
        "Вы избирательно относитесь к себе. Вы склонны принимать не все свои достоинства и критиковать не все свои недостатки.",
        "У вас общий негативный фон восприятия себя, вы склонны воспринимать себя излишне критично. Симпатия к себе недостаточно выражена, проявляется эпизодически. Негативная оценка себя существует в разных формах: от описания себя в комическом свете до самоуничижения."
    ]
    
    
    private let СамопривязанностьIndices = [
        6, 32, 33, 55, 89, 93, 95, 101, 104
    ]
    private let СамопривязанностьDisagreeIndices = [
        96, 11
    ]
    private let СамопривязанностьAdvices = [
        "Ваша \"Я\"-концепция высоко ригидна, вы стремитесь сохранить в неизменном виде свои качества, требования к себе, а глав­ное - видение и оценку себя. Ощущение самодостаточ­ности и достижения идеала мешает реализации возможности саморазвития и самосовершенствования. Помехой для самораскрытия может быть также высокий уровень личностной тревожности, предрасположенность воспринимать окружающий мир как угрожающий самооценке.",
        "Вы избирательно относитесь к своим личностным свойствам, стремитесь к изменению лишь некоторых своих качеств при сохранении прочих других.",
        "У вас высокая готовность к изменению \"Я\"-концепции, открытость новому опыту познания себя, поиску соответствия реального и идеального \"Я\". Вы хотите развивать и совершенствовать собственное \"Я\", источником чего может быть, неудовлетворенность собой. Вы с легкостью изменяете представлений о себе."
    ]
    
    private let ВнутренняяКонфликтностьIndices = [
        4, 11, 22, 23, 27, 38, 47, 59, 64, 67, 69, 81, 91, 94, 99
    ]
    private let ВнутренняяКонфликтностьAdvices = [
        "У вас преобладает негативный фон отношения к себе. Вы находитесь в состоянии постоянного контроля над своим \"Я\", стремитесь к глубокой оценке всего, что происходит в вашем внутреннем мире. Развитая рефлексия переходит в самокопание, приводящее к нахождению осуждаемых в себе качеств и свойств. Вы высоко требовательны к себе, что нередко приводит к конфликту между \"Я\" реальным и \"Я\" идеальным, между уровнем притязаний и фактическими достижениями, к признанию своей малоценности. Истинным источником своих достижений и неудач вы считаете преимущественно себя.",
        "Ваше отношение к себе, установка видеть себя зависит от степени адаптированности в ситуации. В привычных для себя условиях, особенности которых хорошо знакомы и прогнозируемы, наблюдаются положительный фон отношения к себе, признание своих достоинств и высокая оценка своих достижений. Неожиданные трудности, возникающие дополнительные препятствия могут способствовать усилению недооценки собственных успехов.",
        "Вы в целом положительно относитесь к себе, ощущаете баланс между собственными возможностями и требованиями окружающей реальности, между притязаниями и достижениями, довольны сложившейся жизненной ситуацией и собой. При этом возможны отрицание своих проблем и поверхностное восприятие себя."
    ]
    
    private let СамообвинениеIndices = [
        14, 19, 25, 37, 60, 66, 71, 78, 87, 92
    ]
    private let СамообвинениеAdvices = [
        "Вы видите в себе прежде всего недостатки, вы готовы поставить себе в вину все свои промахи и неудачи. Проблемные ситуации, конфликты в сфере общения актуализируют сложившиеся психологические защиты, среди которых доминируют реакции защиты собственного \"Я\" в виде порицания, осуждения себя или привлечения смягчающих обстоятельств. Установка на самообвинение сопровождается развитием внутреннего напряжения, ощущением невозможности удовлетворения основных потребностей.",
        "У вас избирательное отношение к себе. Обвинение себя за те или иные поступки и действия сочетается с выражением гнева, досады в адрес окружающих.",
        "У вас имеется тенденция к отрицанию собственной вины в конфликтных ситуациях. Защита собственного \"Я\" осуществляется путем обвинения преимущественно других, перенесением ответственности на окружающих за устранение барьеров на пути к достижению цели. Ощущение удовлетворенности собой сочетается с порицанием других, поисками в них источников всех неприятностей и бед."
    ]
    
    private let categories = ["Замкнутость", "Самоуверенность", "Саморуководство", "Отраженное самоотношение", "Самоценность", "Самопринятие", "Самопривязанность", "Внутренняя конфликтность", "Самообвинение"]
    
    func calculate(summary: TestAnswerSummary) -> TestResult {
        let answers = summary.answers
        
        var sums: [Int] = []
        for (agreeIndices, disagreeIndices) in zip(
            [ЗамкнутостьIndices, СамоуверенностьIndices, СаморуководствоIndices, ОтраженноеСамоотношениеIndices, СамоценностьIndices, СамопринятиеIndices, СамопривязанностьIndices, ВнутренняяКонфликтностьIndices, СамообвинениеIndices],
            [ЗамкнутостьDisagreeIndices, СамоуверенностьDisagreeIndices, СаморуководствоDisagreeIndices, ОтраженноеСамоотношениеDisagreeIndices, СамоценностьDisagreeIndices, [], СамопривязанностьDisagreeIndices, [], []]
            ) {
                sums.append(getSum(agreeIndices: agreeIndices, disagreeIndices: disagreeIndices, answers: answers))
        }
        
        var stans: [Int] = []
        for (category, sum) in zip(categories, sums) {
            stans.append(getStan(from: category, sum: sum))
        }
        
        var results: [ResultDescription] = []
        var pairs: [Pair] = []
        
        for ((category, stan), advices) in zip(
            zip(categories, stans),
            [ЗамкнутостьAdvices, СамоуверенностьAdvices, СаморуководствоAdvices, ОтраженноеСамоотношениеAdvices, СамоценностьAdvices, СамопринятиеAdvices, СамопривязанностьAdvices, ВнутренняяКонфликтностьAdvices, СамообвинениеAdvices]) {
                results.append(makeResultDescription(for: category, advices: advices, stan: stan))
                pairs.append(Pair(key: "МИС \(category.lowercased())", value: stan))
        }
        
        return TestResult(test: test, results: results, res: Res(title: "МИС", pairs: pairs))
    }
    
}

private extension SelfAttitudeCalculator {
    
    func getSum(agreeIndices: [Int], disagreeIndices: [Int], answers: [TestAnswer]) -> Int {
        var sum = 0
        
        for index in agreeIndices {
            let weight = answers[index - 1].weight
            sum += weight
        }
        
        for index in disagreeIndices {
            var weight = answers[index - 1].weight
            weight = weight == 0 ? 1 : 0
            sum += weight
        }
        
        return sum
    }
    
    func getStan(from category: String, sum: Int) -> Int {
        let mapa: [Int: Int]
        switch category {
        case "Замкнутость":
            mapa = [
                0: 1,
                1: 3,
                2: 4,
                3: 4,
                4: 5,
                5: 5,
                6: 6,
                7: 6,
                8: 7,
                9: 8,
                10: 9,
                11: 10
            ]
            
        case "Самоуверенность":
            mapa = [
                0: 1,
                1: 1,
                2: 2,
                3: 3,
                4: 3,
                5: 4,
                6: 4,
                7: 5,
                8: 5,
                9: 6,
                10: 7,
                11: 7,
                12: 8,
                13: 9,
                14: 10
            ]
            
        case "Саморуководство":
            mapa = [
                0: 1,
                1: 1,
                2: 2,
                3: 3,
                4: 4,
                5: 4,
                6: 5,
                7: 6,
                8: 7,
                9: 8,
                10: 8,
                11: 9,
                12: 10
            ]
            
        case "Отраженное самоотношение":
            mapa = [
                0: 1,
                1: 2,
                2: 3,
                3: 4,
                4: 4,
                5: 5,
                6: 6,
                7: 6,
                8: 7,
                9: 8,
                10: 9,
                11: 10
            ]
            
        case "Самоценность":
            mapa = [
                0: 1,
                1: 1,
                2: 2,
                3: 3,
                4: 4,
                5: 4,
                6: 5,
                7: 5,
                8: 6,
                9: 7,
                10: 7,
                11: 8,
                12: 9,
                13: 10,
                14: 10
            ]
            
        case "Самопринятие":
            mapa = [
                0: 1,
                1: 1,
                2: 2,
                3: 3,
                4: 3,
                5: 4,
                6: 5,
                7: 5,
                8: 6,
                9: 7,
                10: 8,
                11: 9,
                12: 10
            ]
            
        case "Самопривязанность":
            mapa = [
                0: 1,
                1: 2,
                3: 4,
                4: 5,
                5: 5,
                6: 6,
                7: 7,
                8: 7,
                9: 8,
                10: 9,
                11: 10
            ]
            
        case "Внутренняя конфликтность":
            mapa = [
                0: 1,
                1: 2,
                2: 3,
                3: 4,
                4: 4,
                5: 5,
                6: 5,
                7: 5,
                8: 6,
                9: 6,
                10: 6,
                11: 7,
                12: 7,
                13: 8,
                14: 9,
                15: 10
            ]
            
        case "Самообвинение":
            mapa = [
                0: 1,
                1: 2,
                2: 3,
                3: 4,
                4: 4,
                5: 5,
                6: 6,
                7: 6,
                8: 7,
                9: 8,
                10: 9
            ]
        default: fatalError()
        }
        
        return mapa[sum] ?? 10
    }
    
    func makeResultDescription(for category: String, advices: [String], stan: Int) -> ResultDescription {
        let title = "\(category) (\(stan))"
        
        let advice: String
        
        switch stan {
        case 1 ... 3: advice = advices[2]
        case 4 ... 7: advice = advices[1]
        case 8 ... 10: advice = advices[0]
        default: fatalError()
        }
        
        return ResultDescription(title: title, advice: advice)
    }
    
}
